from modules.utils import configGet
from pymongo import MongoClient

db_config = configGet("database")

if db_config["user"] is not None and db_config["password"] is not None:
    con_string = 'mongodb://{0}:{1}@{2}:{3}/{4}'.format(
        db_config["user"],
        db_config["password"],
        db_config["host"],
        db_config["port"],
        db_config["name"]
    )
else:
    con_string = 'mongodb://{0}:{1}/{2}'.format(
        db_config["host"],
        db_config["port"],
        db_config["name"]
    )

db_client = MongoClient(con_string)

db = db_client.get_database(name=db_config["name"])

collections = db.list_collection_names()

for collection in ["saves", "devices", "apikeys", "expired"]:
    if not collection in collections:
        db.create_collection(collection)

col_saves = db.get_collection("saves")
col_devices = db.get_collection("devices")
col_apikeys = db.get_collection("apikeys")
col_expired = db.get_collection("expired")