from os import makedirs
from modules.app import app
from modules.utils import configGet
from modules.extensions_loader import dynamic_import_from_src
from fastapi.responses import FileResponse, Response
from starlette.status import HTTP_200_OK

makedirs(configGet("data", "locations"), exist_ok=True)

@app.get("/check", response_class=Response, include_in_schema=False)
async def check():
    return Response(status_code=HTTP_200_OK)

@app.get("/favicon.ico", response_class=FileResponse, include_in_schema=False)
async def favicon():
    return FileResponse("favicon.ico")

#=================================================================================
dynamic_import_from_src("extensions", star_import = True)
#=================================================================================